/**
 * Dream
 * Copyright (C) 2003-2004 INRIA Rhone-Alpes
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: dream@objectweb.org
 *
 * Initial developer(s): Matthieu Leclercq
 * Contributor(s): Vivien Quema
 */

package org.objectweb.dream.adl.legacy;

import org.objectweb.fractal.adl.bindings.BindingBuilder;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.util.Fractal;

/**
 * Based on {@link org.objectweb.fractal.adl.bindings.FractalBindingBuilder}.
 * unbind client interface if already bound.
 */
public class FractalLegacyBindingBuilder implements BindingBuilder
{

  // --------------------------------------------------------------------------
  // Implementation of the BindingBuilder interface
  // --------------------------------------------------------------------------

  /**
   * @see BindingBuilder#bindComponent(int, Object, String, Object, String,
   *      Object)
   */
  public void bindComponent(final int type, final Object client,
      final String clientItf, final Object server, final String serverItf,
      final Object context) throws Exception
  {
    BindingController bc = Fractal.getBindingController((Component) client);
    Object itf;
    if (type == IMPORT_BINDING)
    {
      itf = Fractal.getContentController((Component) server)
          .getFcInternalInterface(serverItf);
    }
    else
    {
      itf = ((Component) server).getFcInterface(serverItf);
    }
    if (bc.lookupFc(clientItf) != null)
    {
      bc.unbindFc(clientItf);
    }
    bc.bindFc(clientItf, itf);
  }
}
